###################################################
### chunk number 1: 
###################################################
#line 246 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
options(useFancyQuotes = TRUE)


###################################################
### chunk number 2:  eval=FALSE
###################################################
## #line 251 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
## install.packages("svUnit")


###################################################
### chunk number 3: 
###################################################
#line 264 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
library(svUnit)
Square <- function (x) return(x^2)
test(Square) <- function () {
    checkEqualsNumeric(9, Square(3))
    checkEqualsNumeric(10, Square(3))   # This intentionally fails
    checkEqualsNumeric(9, SSSquare(3))  # This raises error
    checkEqualsNumeric(c(1, 4, 9), Square(1:3))
    checkException(Square("xx"))
}
clearLog()
(runTest(Square))


###################################################
### chunk number 4: 
###################################################
#line 300 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
library(svUnit)
## Create two R functions that include their own test cases
Square <- function (x) return(x^2)
test(Square) <- function () {
    checkEqualsNumeric(9, Square(3))
    checkEqualsNumeric(c(4, 9), Square(2:3))
    checkException(Square("xx"))
}

Cube <- function (x) return(x^3)
test(Cube) <- function () {
    checkEqualsNumeric(27, Cube(3))
    checkEqualsNumeric(c(8, 28), Cube(2:3))
    checkException(Cube("xx"))
}

## Add a separate test case
test_Integrate <- svTest(function () {
    checkTrue(1 < 2, "check1")
    v <- c(1, 2, 3)  # The reference
    w <- 1:3         # The value to compare to the reference
    checkEquals(v, w)
})


###################################################
### chunk number 5: 
###################################################
#line 337 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
clearLog()
runTest(Square)
runTest(test_Integrate)
Log()


###################################################
### chunk number 6: 
###################################################
#line 366 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
runTest(Cube)
Log()


###################################################
### chunk number 7: 
###################################################
#line 431 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
clearLog()
checkEqualsNumeric(1, log(exp(1)))
checkException(log("a"))
checkTrue(1 == 2)
Log()


###################################################
### chunk number 8: 
###################################################
#line 498 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
## Clear test exclusion list for running all test suites
options(svUnit.excludeList = NULL)
## Clear the logger
clearLog()
## Run all currently defined tests
runTest(svSuiteList(), name = "AllTests")
## Get some statistics
stats(Log())[, 1:3]
## A slightly different presentation than with print
summary(Log())
## Metadata collected on the machine where tests are run
metadata(Log())
## List content of the log
ls(Log())


###################################################
### chunk number 9: 
###################################################
#line 523 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
myTest <- Log()$testCube
class(myTest)
myTest
summary(myTest)
stats(myTest)


###################################################
### chunk number 10: 
###################################################
#line 537 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
ls(Log())
rm(test_R, envir = Log())
ls(Log())


###################################################
### chunk number 11: 
###################################################
#line 562 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
test_function <- function () {
    checkTrue(1 < 2, "check1")
    v <- c(1, 2, 3)  # The reference
    w <- 1:3         # The object to compare to the reference
    checkEqualsNumeric(v, w)
}
## Turn this function into a test
test_function <- as.svTest(test_function)
is.svTest(test_function)


###################################################
### chunk number 12: 
###################################################
#line 585 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
clearLog()
runTest(test_function)
Log()


###################################################
### chunk number 13: 
###################################################
#line 599 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
## A very simple function
Square <- function (x) return(x^2)

## A test case to associate with the Square() function
test(Square) <- function () {
    checkEqualsNumeric(9, Square(3))
    checkEqualsNumeric(c(1, 4, 9), Square(1:3))
    checkException(Square("xx"))
}
is.test(Square)  # Does this object contain tests?


###################################################
### chunk number 14: 
###################################################
#line 615 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
test(Square)


###################################################
### chunk number 15: 
###################################################
#line 623 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
runTest(Square)
Log()  # Remember we didn't clear the log!


###################################################
### chunk number 16:  eval=FALSE
###################################################
## #line 660 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
## # Create a test unit on disk and view its content
## unit <- makeUnit(Square)
## file.show(unit, delete.file = TRUE)


###################################################
### chunk number 17: 
###################################################
#line 883 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
example(unitTests.svUnit)


###################################################
### chunk number 18: 
###################################################
#line 940 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
## Reset default exclusion list
options(svUnit.excludeList = c("package:sv", "package:RUnit"))
## List all currently available tests 
svSuiteList()


###################################################
### chunk number 19: 
###################################################
#line 954 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
## Clear exclusion list
options(svUnit.excludeList = NULL)
svSuiteList()


###################################################
### chunk number 20: 
###################################################
#line 967 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
(mySuite <- svSuiteList())


###################################################
### chunk number 21:  eval=FALSE
###################################################
## #line 974 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
## myUnit <- makeUnit(mySuite, name = "ExampleTests")
## file.show(myUnit, delete.file = TRUE)


###################################################
### chunk number 22: 
###################################################
#line 988 "d:/Rcompile/CRANpkg/local/2.12/svUnit/inst/doc/svUnit.Rnw"
clearLog()
runTest(mySuite)
summary(Log())


